-- Database: `jinzora2`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `jz_discussions`
-- 

CREATE TABLE `jz_discussions` (
  `my_id` int(11) NOT NULL default '0',
  `date_added` int(11) default NULL,
  `my_user` varchar(32) default NULL,
  `comment` text,
  `path` varchar(255) default NULL,
  PRIMARY KEY  (`my_id`)
);

-- 
-- Dumping data for table `jz_discussions`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_links`
-- 

CREATE TABLE `jz_links` (
  `my_id` int(11) NOT NULL default '0',
  `parent` varchar(255) NOT NULL default '/',
  `path` varchar(255) NOT NULL default '/',
  `type` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`my_id`)
);

-- 
-- Dumping data for table `jz_links`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_nodes`
-- 

CREATE TABLE `jz_nodes` (
  `my_id` varchar(20) NOT NULL default '',
  `name` varchar(255) default NULL,
  `leaf` varchar(5) default 'false',
  `lastplayed` int(11) default '0',
  `playcount` int(11) default '0',
  `directplaycount` int(11) default '0',
  `dlcount` int(11) default '0',
  `viewcount` int(11) default '0',
  `rating` float default '0',
  `rating_count` float default '0',
  `rating_val` float default '0',
  `main_art` varchar(255) default NULL,
  `valid` varchar(5) default 'true',
  `path` varchar(255) NOT NULL default '/',
  `ptype` varchar(20) default NULL,
  `hidden` varchar(10) default 'false',
  `filepath` varchar(255) default '/',
  `level` int(11) default '0',
  `descr` varchar(255) default NULL,
  `longdesc` text,
  `date_added` int(11) default NULL,
  `leafcount` int(11) default '0',
  `nodecount` int(11) default '0',
  `featured` varchar(5) default 'false',
  PRIMARY KEY  (`path`),
  UNIQUE (`my_id`)
);

-- 
-- Dumping data for table `jz_nodes`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_requests`
-- 

CREATE TABLE `jz_requests` (
  `my_id` int(11) NOT NULL default '0',
  `entry` text,
  `comment` text,
  `my_user` varchar(32) default NULL,
  `type` varchar(10) default 'request',
  `path` varchar(255) default NULL,
  PRIMARY KEY  (`my_id`)
);

-- 
-- Dumping data for table `jz_requests`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_tracks`
-- 
CREATE TABLE `jz_tracks` (
  `my_id` varchar(20) NOT NULL default '',
  `path` varchar(255) NOT NULL default '/',
  `filepath` varchar(255) default NULL,
  `name` varchar(255) default NULL,
  `level` int(11) default '0',
  `hidden` varchar(10) default 'false',
  `trackname` varchar(255) default NULL,
  `number` char(3) default '-',
  `valid` varchar(5) default 'true',
  `bitrate` varchar(10) default '-',
  `frequency` varchar(10) default '-',
  `filesize` varchar(10) default '-',
  `length` varchar(10) default '-',
  `genre` varchar(20) default '-',
  `artist` varchar(100) default '-',
  `album` varchar(150) default '-',
  `year` varchar(5) default '-',
  `Description` longtext,
  `Price` int(11) NULL default '0',
  `extension` varchar(5) default NULL,
  `lyrics` text,
  `sheet_music` text,
  PRIMARY KEY  (`path`),
  UNIQUE (`my_id`)
);

-- 
-- Dumping data for table `jz_tracks`
-- 